module Network.Salvia.Handler.ExtendedFileSystem (hExtendedFileSystem) where

import Network.Salvia.Handler.CleverCSS (hFilterCSS, hCleverCSS)
import Network.Salvia.Handler.HsColour (hHighlightHaskell, hHsColour)
import Network.Salvia.Handler.Directory (hDirectoryResource)
import Network.Salvia.Handler.File (hFileResource)
import Network.Salvia.Handler.FileSystem (hFileTypeDispatcher)
import Network.Salvia.Handler.Rewrite (hWithDir)
import Network.Salvia.Httpd (Handler)

hExtendedFileSystem :: FilePath -> Handler ()
hExtendedFileSystem dir =
    hFileTypeDispatcher
    hDirectoryResource
  ( \r -> hHighlightHaskell (hHsColour r)
  $ hWithDir dir
  $ hFilterCSS hCleverCSS
  $ hFileResource r)
  dir


